#pragma once

#include <memory>
#include <nlohmann/json.hpp>
#include <string>

#include "nomad/iot_hub_client_adapter.hxx"

namespace nomad {

/**
 * @brief Interface for telemetry entities that leverage an agent for
 * building messages on the fly.
 */
class Telemetry {
public:
  /**
   * @brief Virtual destructor for the Telemetry class.
   */
  virtual ~Telemetry() {}

  /**
   * @brief Sends the data generated by the agent.
   *
   * @param component The component to send data for.
   */
  virtual void send(const std::string &component) const = 0;
};

/**
 * @brief Standard telemetry corresponding to a single named telemetry.
 * Uses the Template Method Pattern and allows the user to define custom
 * telemetry by implementing the get_telemetry_data() method.
 */
class Basic_Telemetry : public Telemetry {
public:
  /**
   * @brief Constructor for the Basic_Telemetry class.
   *
   * @param client Shared pointer to the IoT_Hub_Client_Adapter.
   */
  Basic_Telemetry(const std::shared_ptr<IoT_Hub_Client_Adapter> &client);

  /**
   * @brief Virtual destructor for the Basic_Telemetry class.
   */
  virtual ~Basic_Telemetry() {}

  /**
   * @brief Sends the telemetry data.
   *
   * @param component The component to send data for.
   */
  void send(const std::string &component) const;

  /**
   * @brief Retrieves the telemetry data.
   *
   * @return The telemetry data.
   */
  virtual nlohmann::json get_telemetry_data() const = 0;

private:
  /**
   * @brief Shared pointer to the IoT_Hub_Client_Adapter.
   */
  std::shared_ptr<IoT_Hub_Client_Adapter> iot_hub_client;
};

/**
 * @brief Compound of several telemetries that leverage a single agent for
 * efficiency. Uses the Template Method Pattern and allows the user to define
 * custom telemetry by implementing the get_telemetry_data() method.
 */
class Compound_Telemetry : public Telemetry {
public:
  /**
   * @brief Constructor for the Compound_Telemetry class.
   *
   * @param client Shared pointer to the IoT_Hub_Client_Adapter.
   */
  Compound_Telemetry(const std::shared_ptr<IoT_Hub_Client_Adapter> &client);

  /**
   * @brief Virtual destructor for the Compound_Telemetry class.
   */
  virtual ~Compound_Telemetry() {}

  /**
   * @brief Sends the telemetry data.
   *
   * @param component The component to send data for.
   */
  void send(const std::string &component) const;

  /**
   * @brief Retrieves a set of telemetry data.
   *
   * @return The telemetry data.
   */
  virtual std::vector<nlohmann::json> get_telemetry_data() const = 0;

private:
  /**
   * @brief Shared pointer to the IoT_Hub_Client_Adapter.
   */
  std::shared_ptr<IoT_Hub_Client_Adapter> iot_hub_client;
};

} // namespace nomad
